from gtk import *
from rox import support
import sys, MySQLdb, fork
from rox import filer
from rox.XDSLoader import XDSLoader

from rox import options
from rox.Menu import Menu
menu_data = [
	('/New Bug',    'enterNewBug',          '',     '<control>N'),
	('/Refresh',	'populateBugList',	'',	'<control>R'),
	('/Options',	'show_options',		''),
	('/Quit',	'close',		'',	'<control>Q'),
	]

try:
	menu = Menu ('Bugs List', 'main', menu_data)
except:
	menu = Menu ('Bugs List', 'main',
		     map (lambda item: item[0:3], menu_data))

options.register('bugs_userid', '1')

class BugWindow(GtkWindow):
	def __init__(self):
		GtkWindow.__init__(self)

		self.clist = GtkCList (7, ("Bug", "Severity", "Priority", 
					   "Status", "Product", "Component", 
					   "Summary"))
		self.set_default_size (500, -1)
		self.add (self.clist)
		self.clist.connect ('button-press-event', self.button_press)
		self.clist.connect ('select-row', self.goToBug)
		menu.attach (self, self)
		self.set_title ("Bugs List")

		support.rox_toplevel_ref()
		self.connect('destroy', self.destroyed)
		self.clist.grab_focus()
		self.show_all()
		self.populateBugList ()
	
	def destroyed(self, window):
		support.rox_toplevel_unref()
	
	def show_options(self):
		options.edit()
	
	def close (self):
		self.destroy ()
	
	def button_press (self, list, event):
		if event.button != 3:
			return 0
		list.emit_stop_by_name ('button-press-event')
		menu.popup (self, event)
		return 1

	def goTo (self, url):
		fork.system ('gnome-moz-remote', '--newwin', url)
	def goToBug (self, clist, row, event, data):
		url = 'http://bugzilla.ojai.lynda.com/show_bug.cgi?id=%s' % \
			clist.get_text (row, 0)
		self.goTo (url)
	def enterNewBug (self):
		self.goTo ('http://bugzilla.ojai.lynda.com/enter_bug.cgi')
	
	def getUserID (self):
		return int (options.get ('bugs_userid'))
	def populateBugList (self):
		query = """
		select bug_id, bug_severity, priority, bug_status,
		       product, component, short_desc
		from bugs
		where assigned_to = %d
		  and bug_status in ('NEW', 'REOPENED', 'ASSIGNED')
		order by priority, bug_severity"""
		self.clist.freeze ()
		self.clist.clear ()
		mysql = MySQLdb.connect (user='bugs', passwd='@whee', db='bugs')
		c = mysql.cursor ()
		c.execute (query % self.getUserID ())
		while 1:
			data = c.fetchone ()
			if data is None: break
			data = list (data)
			data[0] = str (data[0])
			self.clist.append (data)
		self.clist.thaw ()
		timeout_add (100 * 60 * 5, self.populateBugList)
